import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
export declare const protobufPackage = "misc";
export interface HttpHeader {
    name?: string | undefined;
    value?: string | undefined;
}
export interface FormatId {
    itag?: number | undefined;
    lastModified?: number | undefined;
    xtags?: string | undefined;
}
export interface InitRange {
    start?: number | undefined;
    end?: number | undefined;
}
export interface IndexRange {
    start?: number | undefined;
    end?: number | undefined;
}
export interface KeyValuePair {
    key?: string | undefined;
    value?: string | undefined;
}
export declare const HttpHeader: MessageFns<HttpHeader>;
export declare const FormatId: MessageFns<FormatId>;
export declare const InitRange: MessageFns<InitRange>;
export declare const IndexRange: MessageFns<IndexRange>;
export declare const KeyValuePair: MessageFns<KeyValuePair>;
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create<I extends Exact<DeepPartial<T>, I>>(base?: I): T;
    fromPartial<I extends Exact<DeepPartial<T>, I>>(object: I): T;
}
export {};
