import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
import { FormatId, IndexRange, InitRange } from "../misc/common.js";
export declare const protobufPackage = "video_streaming";
export interface FormatInitializationMetadata {
    videoId?: string | undefined;
    formatId?: FormatId | undefined;
    endTimeMs?: number | undefined;
    field4?: number | undefined;
    mimeType?: string | undefined;
    initRange?: InitRange | undefined;
    indexRange?: IndexRange | undefined;
    field8?: number | undefined;
    durationMs?: number | undefined;
    field10?: number | undefined;
}
export declare const FormatInitializationMetadata: MessageFns<FormatInitializationMetadata>;
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create<I extends Exact<DeepPartial<T>, I>>(base?: I): T;
    fromPartial<I extends Exact<DeepPartial<T>, I>>(object: I): T;
}
export {};
